DATA = csvread('stepdata.csv');

time = DATA(:,1);
pwm = DATA(:,2);
position = DATA(:,3);


time = time/1000;
time = time - time(1);





% according to the Rover 5 datasheet, the encoders give 1000 counts per 3 wheel rotations.
% wheels have a diameter of D=6cm
D = 6;
K = 3*pi*D/1000;
position = K*position; % position in cemtimeters

velocity = diff(position);
velocity = [velocity(1);velocity];


ts = 20/1000;
t = transpose(time(1):ts:time(end));

p = interp1(time,position,t);
v = diff(p);
v = [v(1);v];
v = v/ts;

u = interp1(time,pwm,t);

dataid = iddata(v,u,ts);
moe = oe(dataid, [1 1 1]);

ymod = compare(moe,dataid);
ymod = ymod.y;

G = d2c(moe);
s = zpk('s');
Gxu = G*1/s;
PID = pidtune(Gxu,'pid',0.2);
L = PID*Gxu;
T = L/(1+L);

f = figure(1);
set(f,'color','w');
subplot(2,1,1);
plot(t, v,'b');
hold on;
plot(t, ymod,'r');
legend('measured','model');
xlabel('time (s)');
ylabel('speed (cm/s)');
subplot(2,1,2);
plot(t, -u);
xlabel('time (s)');
ylabel('PWM command');
